# -*- coding: utf-8 -*-
#
# Copyright © 2012 Patrick Uiterwijk
#
# This copyrighted material is made available to anyone wishing to use, modify,
# copy, or redistribute it subject to the terms and conditions of the GNU
# General Public License v.2.  This program is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY expressed or implied, including the
# implied warranties of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU General Public License for more details.  You should have
# received a copy of the GNU General Public License along with this program;
# if not, write to the Free Software Foundation, Inc., 51 Franklin Street,
# Fifth Floor, Boston, MA 02110-1301, USA. Any Red Hat trademarks that are
# incorporated in the source code or documentation are not subject to the GNU
# General Public License and may only be used or replicated with the express
# permission of Red Hat, Inc.
#
# Author(s): Patrick Uiterwijk <puiterwijk@fedoraproject.org>
import os
import io
import gpgme

def encrypt_text(receiver, text):
    plaintext = io.BytesIO(text.encode("UTF-8"))
    ciphertext = io.BytesIO()
    ctx = gpgme.Context()
    ctx.armor = True
    recipient = ctx.get_key(receiver)
    ctx.encrypt([recipient], gpgme.ENCRYPT_ALWAYS_TRUST,
            plaintext, ciphertext)
    ciphertext.seek(0)
    return ciphertext.getvalue().replace('\\\\n', '\n')
